/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.service.PlazaService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCiudad;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author MCosso
 */
@Controller("busquedaCiudadController")
@Scope("prototype")
public class BusquedaCiudadController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Ciudad> plwCiudad;
    @Autowired
    private EstadoService estadoService;
    @Autowired
    private PlazaService plazaService;
    private MyListbox ciudadList;
    private Paging pagingCiudad;
    private List<Estado> lsEstado;
    private List<Plaza> lsPlaza;
    private Textbox txtNombre;
    private Textbox txtEquivalencia;
    private Combobox cmbEstado;
    private Combobox cmbPlaza;
    private Row rowEquivalencia;
    private Listheader headerEquivalencia;
    private Intbox txtZonaHoraria;

    public MyListbox getCiudadList() {
        return ciudadList;
    }

    public void setCiudadList(MyListbox ciudadList) {
        this.ciudadList = ciudadList;
    }

    public Combobox getCmbEstado() {
        return cmbEstado;
    }

    public void setCmbEstado(Combobox cmbEstado) {
        this.cmbEstado = cmbEstado;
    }

    public Combobox getCmbPlaza() {
        return cmbPlaza;
    }

    public void setCmbPlaza(Combobox cmbPlaza) {
        this.cmbPlaza = cmbPlaza;
    }

    public List<Estado> getLsEstado() {
        return lsEstado;
    }

    public void setLsEstado(List<Estado> lsEstado) {
        this.lsEstado = lsEstado;
    }

    public List<Plaza> getLsPlaza() {
        return lsPlaza;
    }

    public void setLsPlaza(List<Plaza> lsPlaza) {
        this.lsPlaza = lsPlaza;
    }

    public Paging getPagingCiudad() {
        return pagingCiudad;
    }

    public void setPagingCiudad(Paging pagingCiudad) {
        this.pagingCiudad = pagingCiudad;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    public Intbox getTxtZonaHoraria() {
        return txtZonaHoraria;
    }

    public void setTxtZonaHoraria(Intbox txtZonaHoraria) {
        this.txtZonaHoraria = txtZonaHoraria;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verCiudad(new Ciudad());
    }

    public Listheader getHeaderEquivalencia() {
        return headerEquivalencia;
    }

    public void setHeaderEquivalencia(Listheader headerEquivalencia) {
        this.headerEquivalencia = headerEquivalencia;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsEstado = estadoService.obtenerTodos();
        lsPlaza = plazaService.obtenerTodos();
        super.doAfterCompose(comp);

        ciudadList.setItemRenderer(new RenderCiudad());
        ciudadList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Ciudad ciu = (Ciudad) ciudadList.getSelected();
                verCiudad(ciu);
            }
        });

        refreshLista();

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
            headerEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNombre.focus();
    }

    private void verCiudad(Ciudad ci) {
        if (ci == null) {
            return;
        }

        Map args = new HashMap();
        args.put("ciudad", ci);
        args.put("ciudadList", ciudadList);

        openWindow("/gui/catalogos/editarCiudad.zul",
                Labels.getLabel("editarCiudadController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Ciudad> ciudadBusqueda =
                new HibernateSearchObject<Ciudad>(Ciudad.class, pagingCiudad.getPageSize());

        ciudadBusqueda.addFilterEqual("activo", true);
        ciudadBusqueda.addFilterLike("nombciudad", txtNombre.getText().trim().concat("%"));
        ciudadBusqueda.addFilterNotEqual("ciudadId", -1);

        if (!txtEquivalencia.getText().isEmpty()) {
            ciudadBusqueda.addFilterLike("equivalenciaId", "%" + txtEquivalencia.getText().trim().concat("%"));
        }

        Comboitem cbiEstado = cmbEstado.getSelectedItem();
        Comboitem cbiPlaza = cmbPlaza.getSelectedItem();

        if (cbiEstado != null) {
            Estado estado = (Estado) cbiEstado.getValue();
            ciudadBusqueda.addFilterEqual("estado", estado);
        }

        if (cbiPlaza != null) {
            Plaza plaza = (Plaza) cbiPlaza.getValue();
            ciudadBusqueda.addFilterEqual("plaza", plaza);
        }

        if (txtZonaHoraria.getValue() != null) {
            ciudadBusqueda.addFilterEqual("zonaHoraria", txtZonaHoraria.getValue());
        }

        ciudadBusqueda.addSortAsc("nombciudad");

        plwCiudad.init(ciudadBusqueda, ciudadList, pagingCiudad);

        if (ciudadList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaCiudadController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
