/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.Pais;
import com.rjconsultores.ventaboletos.service.PaisService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEstado;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaEstadoController")
@Scope("prototype")
public class BusquedaEstadoController extends MyGenericForwardComposer {

    @Autowired
    private PaisService paisService;
    @Autowired
    private transient PagedListWrapper<Estado> plwEstado;
    private MyListbox estadoList;
    private Paging pagingEstado;
    private Textbox txtNombre;
    private Textbox txtEquivalencia;
    private Combobox cmbPais;
    private List<Pais> lsPais;
    private Row rowEquivalencia;
    private Listheader headerEquivalencia;

    public Combobox getCmbPais() {
        return cmbPais;
    }

    public void setCmbPais(Combobox cmbPais) {
        this.cmbPais = cmbPais;
    }

    public MyListbox getEstadoList() {
        return estadoList;
    }

    public void setEstadoList(MyListbox estadoList) {
        this.estadoList = estadoList;
    }

    public List<Pais> getLsPais() {
        return lsPais;
    }

    public void setLsPais(List<Pais> lsPais) {
        this.lsPais = lsPais;
    }

    public Paging getPagingEstado() {
        return pagingEstado;
    }

    public void setPagingEstado(Paging pagingEstado) {
        this.pagingEstado = pagingEstado;
    }

    public PaisService getPaisService() {
        return paisService;
    }

    public void setPaisService(PaisService paisService) {
        this.paisService = paisService;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    public Listheader getHeaderEquivalencia() {
        return headerEquivalencia;
    }

    public void setHeaderEquivalencia(Listheader headerEquivalencia) {
        this.headerEquivalencia = headerEquivalencia;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsPais = paisService.obtenerTodos();
        super.doAfterCompose(comp);

        estadoList.setItemRenderer(new RenderEstado());
        estadoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Estado est = (Estado) estadoList.getSelected();
                verPeriodo(est);
            }
        });

        refreshLista();

        
        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
            headerEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNombre.focus();
    }

    public void onClick$btnRefresh(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) throws InterruptedException {
        verPeriodo(new Estado());
    }

    private void verPeriodo(Estado e) {
        if (e == null) {
            return;
        }

        Map args = new HashMap();
        args.put("estado", e);
        args.put("estadoList", estadoList);

        openWindow("/gui/catalogos/editarEstado.zul",
                Labels.getLabel("editarEstadoController.window.title"), args, MODAL);
    }

    private void refreshLista() throws InterruptedException {
        HibernateSearchObject<Estado> estadoBusqueda =
                new HibernateSearchObject<Estado>(Estado.class, pagingEstado.getPageSize());

        estadoBusqueda.addFilterLike("nombestado", "%" + txtNombre.getText().trim().concat("%"));

        Comboitem itemPais = cmbPais.getSelectedItem();
        if (itemPais != null) {
            Pais pais = (Pais) itemPais.getValue();
            estadoBusqueda.addFilterEqual("pais", pais);
        }

        if (!txtEquivalencia.getText().isEmpty()) {
            estadoBusqueda.addFilterLike("equivalenciaId", txtEquivalencia.getText().trim().concat("%"));
        }

        estadoBusqueda.addFilterEqual("activo", Boolean.TRUE);
        estadoBusqueda.addSortAsc("nombestado");
        estadoBusqueda.addFilterNotEqual("estadoId", -1);

        plwEstado.init(estadoBusqueda, estadoList, pagingEstado);

        if (estadoList.getData().length == 0) {
            Messagebox.show(
                    Labels.getLabel("MSG.ningunRegistro"),
                    Labels.getLabel("busquedaEstadoController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
        }
    }
}
