/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Articulo;
import com.rjconsultores.ventaboletos.service.ArticuloService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarArticuloController")
@Scope("prototype")
public class EditarArticuloController extends MyGenericForwardComposer {

    @Autowired
    private ArticuloService articuloService;
    private Articulo articulo;
    private MyListbox articuloList;
    private Button btnApagar;
    private MyTextbox txtNome;
    private static Logger log = Logger.getLogger(EditarArticuloController.class);

    public Articulo getArticulo() {
        return articulo;
    }

    public void setArticulo(Articulo articulo) {
        this.articulo = articulo;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        articulo = (Articulo) Executions.getCurrent().getArg().get("articulo");
        articuloList = (MyListbox) Executions.getCurrent().getArg().get("articuloList");

        if (articulo.getArticuloId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            articulo.setActivo(Boolean.TRUE);
            articulo.setFecmodif(Calendar.getInstance().getTime());
            articulo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Articulo> lsArticulo = articuloService.buscar(articulo.getDescarticulo());

            if (!lsArticulo.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarArticuloController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (articulo.getArticuloId() == null) {
                    articuloService.suscribir(articulo);
                    articuloList.addItem(articulo);
                } else {
                    articuloService.actualizacion(articulo);
                    articuloList.updateItem(articulo);
                }

                Messagebox.show(
                        Labels.getLabel("editarArticuloController.MSG.suscribirOK"),
                        Labels.getLabel("editarArticuloController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarArticuloController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarArticuloController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarArticuloController.MSG.borrarPergunta"),
                    Labels.getLabel("editarArticuloController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                articuloService.borrar(articulo);

                Messagebox.show(
                        Labels.getLabel("editarArticuloController.MSG.borrarOK"),
                        Labels.getLabel("editarArticuloController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                articuloList.removeItem(articulo);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
