/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;

import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Row;

/**
 *
 * @author Rafius
 */
@Controller("editarEmpresaController")
@Scope("prototype")
public class EditarEmpresaController extends MyGenericForwardComposer {

    @Autowired
    private EmpresaService empresaService;
    private Empresa empresa;
    private MyListbox empresaList;
    private static Logger log = Logger.getLogger(EditarEmpresaController.class);
    private MyTextbox txtNome;
    private Button btnApagar;
    private Combobox cmbIndTipo;
    private Checkbox chkExterna;
    private Checkbox chkPagoConductor;
    private Row rowEquivalencia;

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public MyListbox getEmpresaList() {
        return empresaList;
    }

    public void setEmpresaList(MyListbox empresaList) {
        this.empresaList = empresaList;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Combobox getCmbIndTipo() {
        return cmbIndTipo;
    }

    public void setCmbIndTipo(Combobox cmbIndTipo) {
        this.cmbIndTipo = cmbIndTipo;
    }

    public Checkbox getChkExterna() {
        return chkExterna;
    }

    public void setChkExterna(Checkbox chkExterna) {
        this.chkExterna = chkExterna;
    }

    public Checkbox getChkPagoConductor() {
        return chkPagoConductor;
    }

    public void setChkPagoConductor(Checkbox chkPagoConductor) {
        this.chkPagoConductor = chkPagoConductor;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        empresa = (Empresa) Executions.getCurrent().getArg().get("empresa");
        empresaList = (MyListbox) Executions.getCurrent().getArg().get("empresaList");

        txtNome.focus();

        if (empresa.getEmpresaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
            chkExterna.setChecked(true);
        } else {
            chkExterna.setChecked(empresa.getIndExterna() == null ? false : empresa.getIndExterna());
            chkPagoConductor.setChecked(empresa.getPagoConductor() == null ? false : empresa.getPagoConductor());
        }

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
        }
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        cmbIndTipo.getValue();
        try {
            if (empresa.getIndExterna() == null) {
                empresa.setIndExterna(Boolean.FALSE);
            }

            empresa.setActivo(Boolean.TRUE);
            empresa.setFecmodif(Calendar.getInstance().getTime());
            empresa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            empresa.setIndExterna(chkExterna.isChecked());
            empresa.setPagoConductor(chkPagoConductor.isChecked());

            if (empresa.getEmpresaId() == null) {
                List<Empresa> lsEmpresa =
                        empresaService.buscar(empresa.getNombempresa(), empresa.getIndExterna(),
                        empresa.getIndTipo());

                if (!lsEmpresa.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarEmpresaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);

                    return;
                }

                empresaService.suscribir(empresa);
                empresaList.addItem(empresa);
            } else {
                empresaService.actualizacion(empresa);
                empresaList.updateItem(empresa);
            }

            Messagebox.show(
                    Labels.getLabel("editarEmpresaController.MSG.suscribirOK"),
                    Labels.getLabel("editarEmpresaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();

        } catch (Exception ex) {
            log.error("editarEmpresaController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarEmpresaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$chkExterna(Event ev) {
        if (!chkExterna.isChecked()) {
            chkExterna.setChecked(false);
        } else {
            chkExterna.setChecked(true);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarEmpresaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarEmpresaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                empresaService.borrar(empresa);

                Messagebox.show(
                        Labels.getLabel("editarEmpresaController.MSG.borrarOK"),
                        Labels.getLabel("editarEmpresaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                empresaList.removeItem(empresa);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
