/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.Pais;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.service.PaisService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Row;

/**
 *
 * @author Rafius
 */
@Controller("editarEstadoController")
@Scope("prototype")
public class EditarEstadoController extends MyGenericForwardComposer {

    @Autowired
    private EstadoService estadoService;
    @Autowired
    private PaisService paisService;
    private Estado estado;
    private List<Pais> lsPais;
    private MyListbox estadoList;
    private static Logger log = Logger.getLogger(EditarEstadoController.class);
    private MyTextbox txtNome;
    private Combobox cmbPais;
    private Button btnApagar;
    private Row rowEquivalencia;

    public Estado getEstado() {
        return estado;
    }

    public void setEstado(Estado estado) {
        this.estado = estado;
    }

    public MyListbox getEstadoList() {
        return estadoList;
    }

    public void setEstadoList(MyListbox estadoList) {
        this.estadoList = estadoList;
    }

    public EstadoService getEstadoService() {
        return estadoService;
    }

    public void setEstadoService(EstadoService estadoService) {
        this.estadoService = estadoService;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public List<Pais> getLsPais() {
        return lsPais;
    }

    public void setLsPais(List<Pais> lsPais) {
        this.lsPais = lsPais;
    }

    public PaisService getPaisService() {
        return paisService;
    }

    public void setPaisService(PaisService paisService) {
        this.paisService = paisService;
    }

    public Combobox getCmbPais() {
        return cmbPais;
    }

    public void setCmbPais(Combobox cmbPais) {
        this.cmbPais = cmbPais;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsPais = paisService.obtenerTodos();
        super.doAfterCompose(comp);

        estado = (Estado) Executions.getCurrent().getArg().get("estado");
        estadoList = (MyListbox) Executions.getCurrent().getArg().get("estadoList");

        if (estado.getEstadoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        cmbPais.getValue();
        try {

            estado.setActivo(Boolean.TRUE);
            estado.setFecmodif(Calendar.getInstance().getTime());
            estado.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Estado> lsEstado = estadoService.buscar(estado.getNombestado(), estado.getPais());

            boolean podeSalvar = false;
            if (lsEstado.isEmpty()) {
                podeSalvar = true;
            } else {
                if (estado.getEstadoId() == null) {
                    podeSalvar = false;
                } else {
                    for (Estado e : lsEstado) {
                        if (e.getEstadoId().equals(estado.getEstadoId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            if (podeSalvar) {
                if (estado.getEstadoId() == null) {
                    estadoService.suscribir(estado);
                    estadoList.addItem(estado);
                } else {
                    estadoService.actualizacion(estado);
                    estadoList.updateItem(estado);
                }
                Messagebox.show(
                        Labels.getLabel("editarEstadoController.MSG.suscribirOK"),
                        Labels.getLabel("editarEstadoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarEstadoController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }

        } catch (Exception ex) {
            log.error("editarEstadoController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarEstadoController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarEstadoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarEstadoController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                estadoService.borrar(estado);

                Messagebox.show(
                        Labels.getLabel("editarEstadoController.MSG.borrarOK"),
                        Labels.getLabel("editarEstadoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                estadoList.removeItem(estado);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
