/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderComisionistaExterno;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaComisionistaExternoController")
@Scope("prototype")
public class BusquedaComisionistaExternoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ComisionistaExterno> plwComisionistaExterno;
    private MyListbox comisionistaExternoList;
    private Paging pagingComisionistaExterno;
    private Textbox txtNombre;

    public MyListbox getComisionistaExternoList() {
        return comisionistaExternoList;
    }

    public void setComisionistaExternoList(MyListbox comisionistaExternoList) {
        this.comisionistaExternoList = comisionistaExternoList;
    }

    public Paging getPagingComisionistaExterno() {
        return pagingComisionistaExterno;
    }

    public void setPagingComisionistaExterno(Paging pagingComisionistaExterno) {
        this.pagingComisionistaExterno = pagingComisionistaExterno;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        comisionistaExternoList.setItemRenderer(new RenderComisionistaExterno());
        comisionistaExternoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ComisionistaExterno c = (ComisionistaExterno) comisionistaExternoList.getSelected();
                verComisionistaExterno(c);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verComisionistaExterno(ComisionistaExterno c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("comisionistaExterno", c);
        args.put("comisionistaExternoList", comisionistaExternoList);

        openWindow("/gui/configuraciones_comerciales/editarComisionistaExterno.zul",
                Labels.getLabel("editarComisionistaExternoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ComisionistaExterno> comisionistaExternoBusqueda =
                new HibernateSearchObject<ComisionistaExterno>(ComisionistaExterno.class, pagingComisionistaExterno.getPageSize());

        comisionistaExternoBusqueda.addFilterLike("desccomisionista",
                "%" + txtNombre.getText().trim().concat("%"));
        comisionistaExternoBusqueda.addFilterEqual("activo", Boolean.TRUE);

        comisionistaExternoBusqueda.addSortAsc("desccomisionista");

        plwComisionistaExterno.init(comisionistaExternoBusqueda, comisionistaExternoList, pagingComisionistaExterno);

        if (comisionistaExternoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaComisionistaExternoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verComisionistaExterno(new ComisionistaExterno());
    }
}
