/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCatalogoDeRutas;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaCatalogoDeRutaController")
@Scope("prototype")
public class BusquedaCatalogoDeRutaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Ruta> plwRuta;
    @Autowired
    private ClaseServicioService claseServicioServicce;
    private List<ClaseServicio> lsClaseServicio;
    private MyListbox rutaList;
    private Paging pagingRuta;
    private Textbox txtNombre;
    private Intbox txtId;
    private Combobox cmbClaseServicio;

    public Paging getPagingRuta() {
        return pagingRuta;
    }

    public void setPagingRuta(Paging pagingRuta) {
        this.pagingRuta = pagingRuta;
    }

    public MyListbox getRutaList() {
        return rutaList;
    }

    public void setRutaList(MyListbox rutaList) {
        this.rutaList = rutaList;
    }

    public PagedListWrapper<Ruta> getPlwRuta() {
        return plwRuta;
    }

    public void setPlwRuta(PagedListWrapper<Ruta> plwRuta) {
        this.plwRuta = plwRuta;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new Ruta());
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public Intbox getTxtId() {
        return txtId;
    }

    public void setTxtId(Intbox txtId) {
        this.txtId = txtId;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsClaseServicio = claseServicioServicce.obtenerTodos();

        super.doAfterCompose(comp);

        rutaList.setItemRenderer(new RenderCatalogoDeRutas());
        rutaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Ruta c = (Ruta) rutaList.getSelected();
                verPeriodo(c);
            }
        });

        refreshLista();

        txtId.focus();
    }

    private void verPeriodo(Ruta c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("ruta", c);
        args.put("rutaList", rutaList);

        openWindow("/gui/esquema_operacional/editarRuta.zul",
                Labels.getLabel("editarCatalogoDeRutaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Ruta> claseServicioBusqueda =
                new HibernateSearchObject<Ruta>(Ruta.class, pagingRuta.getPageSize());
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        claseServicioBusqueda.addFilterNotEqual("rutaId", -1);
        if (txtId.getValue() != null) {
            claseServicioBusqueda.addFilterEqual("rutaId", txtId.getValue());
        }

        claseServicioBusqueda.addFilterLike("descruta",
                "%" + txtNombre.getText().trim().concat("%"));

        Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
        if (cbiClaseServicio != null) {
            ClaseServicio claseServicio = (ClaseServicio) cbiClaseServicio.getValue();
            claseServicioBusqueda.addFilterEqual("claseServicio", claseServicio);
        }

        claseServicioBusqueda.addSortAsc("descruta");

        plwRuta.init(claseServicioBusqueda, rutaList, pagingRuta);
        if (rutaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaCatalogoDeRutaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
