/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.recaudacion;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.TarjetaRecaudacion;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCorridaTarjetaRecaudacion;
import java.util.Date;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Timebox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaCorridaTarjetaRecaudacionController")
@Scope("prototype")
public class BusquedaCorridaTarjetaRecaudacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Corrida> plwCorrida;
    @Autowired
    private ClaseServicioService claseServicioService;
    private List<ClaseServicio> lsClaseServicio;
    private MyListbox corridaList;
    private Paging pagingCorrida;
    private Intbox idCorrida;
    private Combobox cmbParadaOrigem;
    private Combobox cmbParadaDestino;
    private Combobox cmbTipoServicio;
    private Timebox timeInicio;
    private Timebox timeFin;
    private TarjetaRecaudacion tarjetaRecaudacion;
    private EditarTarjetaRecaudacionController editarTarjetaRecaudacionController;
    private static Logger log = Logger.getLogger(BusquedaCorridaTarjetaRecaudacionController.class);

    public Combobox getCmbParadaDestino() {
        return cmbParadaDestino;
    }

    public void setCmbParadaDestino(Combobox cmbParadaDestino) {
        this.cmbParadaDestino = cmbParadaDestino;
    }

    public Combobox getCmbParadaOrigem() {
        return cmbParadaOrigem;
    }

    public void setCmbParadaOrigem(Combobox cmbParadaOrigem) {
        this.cmbParadaOrigem = cmbParadaOrigem;
    }

    public Combobox getCmbTipoServicio() {
        return cmbTipoServicio;
    }

    public void setCmbTipoServicio(Combobox cmbTipoServicio) {
        this.cmbTipoServicio = cmbTipoServicio;
    }

    public MyListbox getCorridaList() {
        return corridaList;
    }

    public void setCorridaList(MyListbox corridaList) {
        this.corridaList = corridaList;
    }

    public Intbox getIdCorrida() {
        return idCorrida;
    }

    public void setIdCorrida(Intbox idCorrida) {
        this.idCorrida = idCorrida;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public Paging getPagingCorrida() {
        return pagingCorrida;
    }

    public void setPagingCorrida(Paging pagingCorrida) {
        this.pagingCorrida = pagingCorrida;
    }

    public Timebox getTimeFin() {
        return timeFin;
    }

    public void setTimeFin(Timebox timeFin) {
        this.timeFin = timeFin;
    }

    public Timebox getTimeInicio() {
        return timeInicio;
    }

    public void setTimeInicio(Timebox timeInicio) {
        this.timeInicio = timeInicio;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsClaseServicio = claseServicioService.buscarTodosExceto(-1);

        super.doAfterCompose(comp);

        tarjetaRecaudacion =
                (TarjetaRecaudacion) Executions.getCurrent().getArg().get("tarjetaRecaudacion");
        editarTarjetaRecaudacionController =
                (EditarTarjetaRecaudacionController) Executions.getCurrent().getArg().get("editarTarjetaRecaudacionController");

        corridaList.setItemRenderer(new RenderCorridaTarjetaRecaudacion());
        corridaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                selecionarCorrida();
            }
        });
    }

    private void refreshLista() {
        HibernateSearchObject<Corrida> corridaSearch =
                new HibernateSearchObject<Corrida>(Corrida.class,
                pagingCorrida.getPageSize());

        if (idCorrida.getValue() != null) {
            corridaSearch.addFilterEqual("id.corridaId", idCorrida.getValue());
        }

        Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
        if (cbiOrigem != null) {
            Parada origem = (Parada) cbiOrigem.getValue();
            corridaSearch.addFilterEqual("origem", origem);
        }

        Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
        if (cbiDestino != null) {
            Parada destino = (Parada) cbiDestino.getValue();
            corridaSearch.addFilterEqual("destino", destino);
        }

        Comboitem cbiTipoServicio = cmbTipoServicio.getSelectedItem();
        if (cbiTipoServicio != null) {
            ClaseServicio calseServicio = (ClaseServicio) cbiTipoServicio.getValue();
            corridaSearch.addFilterEqual("claseServicio", calseServicio);
        }

        Date horaInicio = timeInicio.getValue();
        if (horaInicio != null) {
            corridaSearch.addFilterGreaterOrEqual("corridaCtrl.horario", horaInicio);
        }

        Date horaFin = timeFin.getValue();
        if (horaFin != null) {
            corridaSearch.addFilterLessOrEqual("corridaCtrl.horario", horaFin);
        }

        corridaSearch.addFilterEqual("activo", Boolean.TRUE);

        corridaSearch.addSortAsc("id.feccorrida");

        plwCorrida.init(corridaSearch, corridaList, pagingCorrida);

        if (corridaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaPricingController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    private void selecionarCorrida() {
        try {
            Corrida corrida = (Corrida) corridaList.getSelected();

            if (corrida != null) {
                tarjetaRecaudacion.setCorrida(corrida);

                Integer corridaId = corrida.getId().getCorridaId();
                Date fecHor = corrida.getId().getFeccorrida();

                editarTarjetaRecaudacionController.atualizarCorridaTela(fecHor, corridaId);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        cmbParadaOrigem.clearErrorMessage();
        cmbParadaDestino.clearErrorMessage();
        cmbTipoServicio.clearErrorMessage();

        if (idCorrida.getValue() == null) {
            cmbParadaOrigem.setConstraint("no empty");
            cmbParadaDestino.setConstraint("no empty");
            cmbTipoServicio.setConstraint("no empty");

            cmbParadaOrigem.getValue();
            cmbParadaDestino.getValue();
            cmbTipoServicio.getValue();
        }

        refreshLista();
    }

    public void onClick$btnAdicionarCorrida(Event ev) throws Exception {
        selecionarCorrida();
    }
}
